﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using C1.Win.C1FlexGrid;

namespace TicTacToe
{
    public partial class Form1 : Form
    {
        int click = 0;
        int sec = 0;
        bool hor = true, ver = true, dia = true, oppDia = true, won = false;
        MyMessageBox mmb;

        // constructor
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            // adjusting height of rows and width of columns of C1FlexGrid.
            foreach (Row r in c1FlexGrid1.Rows)
            {
                r.Height = c1FlexGrid1.Height / 3;
                r.ImageAlign = ImageAlignEnum.Scale;
            }
            foreach (Column c in c1FlexGrid1.Cols)
            {
                c.Width = c1FlexGrid1.Width / 3;
            }
            c1FlexGrid1.Styles.Highlight.BackColor = Color.Transparent; // setting grid's highlight color to transparent.
        }

        // closing the form on click of 'X' button
        private void closeButton_Click(object sender, EventArgs e)
        {
            Close();
        }

        // resetting the properties of the object's on click of reset button.
        private void resetButton_Click(object sender, EventArgs e)
        {
            v1Label.Visible = false;
            v2Label.Visible = false;
            v3Label.Visible = false;
            h1Label.Visible = false;
            h2Label.Visible = false;
            h3Label.Visible = false;
            lineShape1.Visible = false;
            lineShape2.Visible = false;
            player1TextBox.Enabled = true;
            player2TextBox.Enabled = true;
            c1FlexGrid1.Visible = false;
            menuGroupBox.Visible = false;
            c1FlexGrid1.Enabled = false;
            playButton.Enabled = true;
            c1FlexGrid1.Clear();
        }

        // implementing the main game logic on C1FlexGrid's mouse click.
        private void c1FlexGrid1_MouseClick(object sender, MouseEventArgs e)
        {           
            hor = true;
            ver = true;
            dia = true;
            oppDia = true;
            if (click <= 9 && c1FlexGrid1.GetCellImage(c1FlexGrid1.Row, c1FlexGrid1.Col) == null)
            {
                if (e.Button == MouseButtons.Left && click % 2 != 0)
                {
                    c1FlexGrid1.SetCellImage(c1FlexGrid1.Row, c1FlexGrid1.Col, Image.FromFile(@"..\..\Images\O1.png"));
                    turnLabel.Text = player2TextBox.Text;
                    c1FlexGrid1.SetUserData(c1FlexGrid1.Row, c1FlexGrid1.Col, player1TextBox.Text);
                }
                else
                {
                    c1FlexGrid1.SetCellImage(c1FlexGrid1.Row, c1FlexGrid1.Col, Image.FromFile(@"..\..\Images\X.png"));
                    turnLabel.Text = player1TextBox.Text;
                    c1FlexGrid1.SetUserData(c1FlexGrid1.Row, c1FlexGrid1.Col, player2TextBox.Text);
                }
                object userData = c1FlexGrid1.GetUserData(c1FlexGrid1.Row, c1FlexGrid1.Col);
                int j = 2;
                for (int i = 0; i < 3; i++)
                {
                    if (c1FlexGrid1.GetUserData(c1FlexGrid1.Row, i) != null)
                    {
                        if (userData.ToString() != (c1FlexGrid1.GetUserData(c1FlexGrid1.Row, i)).ToString() && ver == true)
                        {
                            ver = false;
                        }
                    }
                    else
                        ver = false;
                    if (c1FlexGrid1.GetUserData(i, c1FlexGrid1.Col) != null)
                    {
                        if (userData.ToString() != (c1FlexGrid1.GetUserData(i, c1FlexGrid1.Col)).ToString() && hor == true)
                        {
                            hor = false;
                        }
                    }
                    else
                        hor = false;
                    if (c1FlexGrid1.Row == c1FlexGrid1.Col)
                    {
                        if (c1FlexGrid1.GetUserData(i, i) != null)
                        {
                            if (userData.ToString() != (c1FlexGrid1.GetUserData(i, i)).ToString() && dia == true)
                            {
                                dia = false;
                            }
                        }
                        else
                            dia = false;
                    }
                    if ((c1FlexGrid1.Row + c1FlexGrid1.Col) == 2)
                    {
                        if (j > -1)
                        {
                            if (c1FlexGrid1.GetUserData(i, j) != null)
                            {
                                if (userData.ToString() != (c1FlexGrid1.GetUserData(i, j--)).ToString() && oppDia == true)
                                {
                                    oppDia = false;
                                }
                            }
                            else
                                oppDia = false;
                        }
                    }
                    if (ver == false && hor == false && dia == false && oppDia == false)
                    {
                        break;
                    }
                }
                if (ver == true)
                {
                    won = true;
                    if (c1FlexGrid1.Row == 0)
                        h1Label.Visible = true;
                    if (c1FlexGrid1.Row == 1)
                        h2Label.Visible = true;
                    if (c1FlexGrid1.Row == 2)
                        h3Label.Visible = true;
                    c1FlexGrid1.Enabled = false;
                    mmb = new MyMessageBox(resetButton, true);
                    mmb.MsgText = "Congrats! " + userData.ToString().ToUpper() + " Won";
                    mmb.ShowDialog();
                    click = 10;
                }
                else if (hor == true)
                {
                    won = true;
                    if (c1FlexGrid1.Col == 0)
                        v1Label.Visible = true;
                    if (c1FlexGrid1.Col == 1)
                        v2Label.Visible = true;
                    if (c1FlexGrid1.Col == 2)
                        v3Label.Visible = true;
                    c1FlexGrid1.Enabled = false;
                    mmb = new MyMessageBox(resetButton, true);
                    mmb.MsgText = "Congrats! " + userData.ToString().ToUpper() + " Won";
                    mmb.ShowDialog();
                    click = 10;
                }
                else if (c1FlexGrid1.Row == c1FlexGrid1.Col && dia == true)
                {
                    won = true;
                    lineShape2.Visible = true;
                    c1FlexGrid1.SendToBack();
                    lineShape2.BringToFront();
                    c1FlexGrid1.Enabled = false;
                    mmb = new MyMessageBox(resetButton, true);
                    mmb.MsgText = "Congrats! " + userData.ToString().ToUpper() + " Won";
                    mmb.ShowDialog();
                    click = 10;
                }
                else if ((c1FlexGrid1.Row + c1FlexGrid1.Col) == 2 && oppDia == true)
                {
                    won = true;
                    lineShape1.Visible = true;
                    c1FlexGrid1.SendToBack();
                    lineShape1.BringToFront();
                    c1FlexGrid1.Enabled = false;
                    mmb = new MyMessageBox(resetButton, true);
                    mmb.MsgText = "Congrats! " + userData.ToString().ToUpper() + " Won";
                    mmb.ShowDialog();
                    click = 10;
                }
                click++;
            }
            if (click > 9 && won == false)
            {
                mmb = new MyMessageBox(resetButton, false);
                mmb.MsgText = "Try Again!.";
                mmb.ShowDialog();
            }            
        }

        // activating necessary control visible and activating them to enable the users to play game on play button's click event.
        private void playButton_Click(object sender, EventArgs e)
        {
            if (player1TextBox.Text != string.Empty && player2TextBox.Text != string.Empty && player1TextBox.Text != player2TextBox.Text)
            {
                won = false;                
                click = 0;
                player1TextBox.Enabled = false;
                player2TextBox.Enabled = false;
                c1FlexGrid1.Visible = true;
                menuGroupBox.Visible = true;
                c1FlexGrid1.Enabled = true;
                playButton.Enabled = false;
                resetButton.Visible = true;
                sec = 0;
                stopWatchTimer.Start();
                foreach (Row r in c1FlexGrid1.Rows)
                {
                    r.Height = c1FlexGrid1.Height / 3;
                    r.ImageAlign = ImageAlignEnum.Scale;
                }
                foreach (Column c in c1FlexGrid1.Cols)
                {
                    c.Width = c1FlexGrid1.Width / 3;
                }
                turnLabel.Text = player1TextBox.Text;
                click++;
            }
            else
            {
                mmb = new MyMessageBox();
                mmb.MsgText = "Please Enter Player Names Correctly.";
                mmb.ShowDialog();
            }
        }

        // counting the elapsed time.
        private void stopWatchTimer_Tick(object sender, EventArgs e)
        {
            timeLabel.Text = (++sec).ToString() + "secs";
        }

        // performing minimize operation on form's window.
        private void minButton_Click(object sender, EventArgs e)
        {
            this.WindowState = FormWindowState.Minimized;
        }

        // changing cursor's style.
        private void playButton_MouseEnter(object sender, EventArgs e)
        {
            Cursor.Current = Cursors.Hand;
        }

        private void playButton_MouseLeave(object sender, EventArgs e)
        {
            Cursor.Current = Cursors.Default;
        }

        private void resetButton_MouseEnter(object sender, EventArgs e)
        {
            Cursor.Current = Cursors.Hand;
        }

        private void resetButton_MouseLeave(object sender, EventArgs e)
        {
            Cursor.Current = Cursors.Default;
        }

        private void playButton_MouseHover(object sender, EventArgs e)
        {
            Cursor.Current = Cursors.Hand;
        }

        private void resetButton_MouseHover(object sender, EventArgs e)
        {
            Cursor.Current = Cursors.Hand;
        }

        private void resetButton_MouseMove(object sender, MouseEventArgs e)
        {
            Cursor.Current = Cursors.Hand;
        }

        private void playButton_MouseMove(object sender, MouseEventArgs e)
        {
            Cursor.Current = Cursors.Hand;
        }      
    }
}
